import torch
from torch_geometric.transforms import RandomFlip
from torch_geometric.data import Data


def test_random_flip():
    assert RandomFlip(axis=0).__repr__() == 'RandomFlip(axis=0, p=0.5)'

    pos = torch.Tensor([[-1, 1], [-3, 0], [2, -1]])

    data = Data(pos=pos)
    data = RandomFlip(axis=0, p=1)(data)
    assert len(data) == 1
    assert data.pos.tolist() == [[1, 1], [3, 0], [-2, -1]]

    data = Data(pos=pos)
    data = RandomFlip(axis=1, p=1)(data)
    assert len(data) == 1
    assert data.pos.tolist() == [[-1, -1], [-3, 0], [2, 1]]
